/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "music.h"
#include "patcher.h"
#include "xcom.h"

#define MCI_QUEUE_SIZE 4
static char mciString[MCI_QUEUE_SIZE][256];
static HWND mciHwnd[MCI_QUEUE_SIZE];
static int msgRead=0;
static int msgWrite=0;
static HANDLE mciSemaphoreRead;
static HANDLE mciSemaphoreWrite;

static MCIERROR WINAPI myMciSendString(LPCSTR lpszCommand, LPSTR lpszReturnString, UINT cchReturn, HWND hwndCallback)
{
	WaitForSingleObject(mciSemaphoreWrite,INFINITE);
	strcpy(mciString[msgWrite],lpszCommand);
	mciHwnd[msgWrite]=hwndCallback;
	msgWrite=(msgWrite+1)%MCI_QUEUE_SIZE;
	ReleaseSemaphore(mciSemaphoreRead,1,NULL);
	//Must put that here or there is no music!
	Sleep(10);
	return 0;
}

static DWORD WINAPI MusicThread(LPVOID lpThreadParameter)
{
	while(true)
	{
		WaitForSingleObject(mciSemaphoreRead,INFINITE);
		mciSendStringA(mciString[msgRead],0,0,mciHwnd[msgRead]);
		msgRead=(msgRead+1)%MCI_QUEUE_SIZE;
		ReleaseSemaphore(mciSemaphoreWrite,1,NULL);
	}
}


void ClickPauseBug()
{
	mciSemaphoreRead=CreateSemaphore(NULL,0,1,NULL);
	mciSemaphoreWrite=CreateSemaphore(NULL,MCI_QUEUE_SIZE,1,NULL);
	CreateThread(NULL,0,MusicThread,NULL,0,NULL);

	DWORD toto=(DWORD)&myMciSendString;
	PatchInPlace(0x469160,&toto,4);
}


/*
void PlayMP3MusicFile(char *filename)
{
	char buf[256];
	sprintf(buf,"open \"%s\" type mpegvideo alias MUSIC",filename);
	mciSendStringA("close MUSIC",NULL,0,NULL);
	mciSendStringA(buf,NULL,0,NULL);
	mciSendStringA("play MUSIC from 0 notify",NULL,0,NULL);
}


void PlayMP3Music()
{
	int id=*CurrentMidiPlaying-0x80;
	char *filename="C:\\Documents and Settings\\Gondos\\Mes documents\\Ma musique\\Katie Melua\\Pictures\\09 Ghost Town.mp3";
	switch(id)
	{
	default:
		;
	}
	PlayMP3MusicFile(filename);
}
*/

void PlayCDMusicTrack(int track)
{
	static char open_cmd[256];
	static int init=0;
	char buf[256];

	if(!init)
	{
		init=1;
		INI_READ_STRING("Music","CD Drive","F",buf,2);
		sprintf(open_cmd,"open %s:\\ type cdaudio alias MUSIC wait",buf);
	}
	mciSendStringA("close MUSIC",NULL,0,NULL);
	mciSendStringA(open_cmd,NULL,0,NULL);
	mciSendStringA("set MUSIC time format tmsf wait",NULL,0,NULL);
	sprintf(buf,"play MUSIC from %d notify",track);

	mciSendStringA(buf,NULL,0,NULL);
}
/*
PSX tracks mapping details:
-1,2,3,4: geoscape
-5: gmdefend
-6: gmenbase
-7: gmmars
-8: gminter
-9: gmstory
-10,11: battlescape
-12: gmnewmar

gmwin and gmlose are not available. Because of similarity, gmlose is replaced with gmstory
and gmwin with gminter
*/

void PlayCDMusic()
{
	static int geo_track=1;
	static int tac_track=10;
	int id=*CurrentMidiPlaying-0x80;
	int track=0;

	switch(id) {
		//Geoscape music 1/2. Modify to play the 4 first tracks of the CD repeatedly
		case 0:
		case 18:
			track=geo_track;
			geo_track=geo_track+1;
			if(geo_track==5)
				geo_track=1;
			break;
		//Interception
		case 2:
			track=8;
			break;
		//GMDEFEND?
		case 3:
		case 4:
			track=5;
			break;
		//GMENBASE
		case 6:
		case 7:
			track=6;
			break;
		//GMMARS
		case 8:
			track=7;
			break;
		//GMLOSE
		case 10:
			track=9;
			break;
		//GMWIN
		case 11:
			track=8;
			break;
		//GMSTORY
		case 9:
		case 12:
			track=9;
			break;
		//GMTACTIC
		case 13:
			track=tac_track;
			tac_track^=1;
			break;
		//No corresponding music on CE edition
		default:
		case 1:
		case 5:
		case 14:
		case 15:
		case 16:
		case 17:
			return;
	}

	//Tracks are off by one because of the data track
	track++;
	PlayCDMusicTrack(track);
}

void StopCDMusic()
{
	static char open_cmd[64];
	static int init=0;

	if(!init)
	{
		char buf[3];
		init=1;
		INI_READ_STRING("Music","CD Drive","F",buf,2);
		sprintf(open_cmd,"open %s:\\ type cdaudio alias MUSIC wait",buf);
	}

	mciSendStringA(open_cmd,NULL,0,NULL);
	mciSendStringA("stop MUSIC",NULL,0,NULL);
	mciSendStringA("close MUSIC",NULL,0,NULL);
}


void ModMusic()
{
	//mov CurrentMidiPlaying, esi
	//pop edi
	//pop esi
	char patch_music[]={ 0x89, 0x35, 0xE8, 0x58, 0x47, 0x00, 0x5F, 0x5E };
	PatchInPlace(0x45D991,patch_music,8);
	InsertJmp(0x45D991+8,PlayCDMusic);
	InsertJmp(0x45C7A5,StopCDMusic);
}
