/* UFO Extender - Mod for X-COM
 * See <http://www.ufopaedia.org/index.php?title=User:Seb76> for more details.
 * Copyright (C) 2008 Seb76
 *
 * This file is part of UFO Extender.

 * UFO Extender is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * UFO Extender is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with UFO Extender.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "stdafx.h"
#include "xcom.h"
#include "patcher.h"
#include "video.h"

void FixPitch(char *src);
void BlitImage2xScale2x(char *src);
void BlitImage4x(char *src);

int mouse_scaling = 1;

typedef char scale2x_uint8;
void scale2x_8_def(scale2x_uint8* dst0, scale2x_uint8* dst1, const scale2x_uint8* src0, const scale2x_uint8* src1, const scale2x_uint8* src2, unsigned count);

__declspec(naked) void ScaleMouse()
{
	__asm pusha

	(*mouse_xpos)/=mouse_scaling;
	(*mouse_ypos)/=mouse_scaling;


	__asm
	{
		popa
		xor eax,eax
		retn 0x10
	}
}

void SetScalingMethod(int method)
{
	switch(method)
	{
		case 1: //2x
			{
				/*
				.text:0045C61C A1 FC 85 47 00                mov     eax, pDirectDraw
				.text:0045C621 6A 08                         push    8                               ; DWORD
				.text:0045C623 68 C8 00 00 00                push    200                             ; DWORD
				.text:0045C628 68 40 01 00 00                push    320                             ; DWORD
				.text:0045C62D 8B 08                         mov     ecx, [eax+IDirectDraw.lpVtbl]
				.text:0045C62F 50                            push    eax                             ; This
				.text:0045C630 FF 51 54                      call    [ecx+IDirectDraw3Vtbl.SetDisplayMode]
				*/
				char bpp[]={8};
				short width[]={1280};
				short height[]={800};
				PatchInPlace(0x45C621+1,bpp,1);
				PatchInPlace(0x45C623+1,height,2);
				PatchInPlace(0x45C628+1,width,2);

				InsertJmp(0x42FF10,BlitImage4x);

				mouse_scaling = 4;
			}
			break;
		case 2: //scale2x
			{
				/*
				.text:0045C61C A1 FC 85 47 00                mov     eax, pDirectDraw
				.text:0045C621 6A 08                         push    8                               ; DWORD
				.text:0045C623 68 C8 00 00 00                push    200                             ; DWORD
				.text:0045C628 68 40 01 00 00                push    320                             ; DWORD
				.text:0045C62D 8B 08                         mov     ecx, [eax+IDirectDraw.lpVtbl]
				.text:0045C62F 50                            push    eax                             ; This
				.text:0045C630 FF 51 54                      call    [ecx+IDirectDraw3Vtbl.SetDisplayMode]
				*/
				char bpp[]={8};
				short width[]={1280};
				short height[]={800};
				PatchInPlace(0x45C621+1,bpp,1);
				PatchInPlace(0x45C623+1,height,2);
				PatchInPlace(0x45C628+1,width,2);

				InsertJmp(0x42FF10,BlitImage2xScale2x);

				mouse_scaling = 4;
			}
			break;
		default:
			InsertJmp(0x42FF10,FixPitch);
			mouse_scaling = 1;
			break;
	}
	InsertJmp(0x45E142,ScaleMouse);
}

/*
 * Fix the garbled screen problem by taking into account the surface's pitch
 */
void FixPitch(char *src)
{
	if(char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		for(int i=0;i<200;i++)
		{
			memcpy(dst,src,320);
			dst+=pitch;
			src+=320;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
}

void BlitImage4x(char *src)
{
	if(char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		for(int i=0;i<200;i++)
		{
			for(int j=0;j<320;j++)
			{
				*(dst+4*j) = *src;
				*(dst+4*j+1) = *src;
				*(dst+4*j+2) = *src;
				*(dst+4*j+3) = *src;
				*(dst+pitch+4*j) = *src;
				*(dst+pitch+4*j+1) = *src;
				*(dst+pitch+4*j+2) = *src;
				*(dst+pitch+4*j+3) = *src;
				*(dst+2*pitch+4*j) = *src;
				*(dst+2*pitch+4*j+1) = *src;
				*(dst+2*pitch+4*j+2) = *src;
				*(dst+2*pitch+4*j+3) = *src;
				*(dst+3*pitch+4*j) = *src;
				*(dst+3*pitch+4*j+1) = *src;
				*(dst+3*pitch+4*j+2) = *src;
				*(dst+3*pitch+4*j+3) = *src;


				src++;
			}
			
			dst+=pitch;
			dst+=pitch;
			dst+=pitch;
			dst+=pitch;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
}

void BlitImage2xScale2x(char *src)
{
	if(char *dst=DD_SurfaceLock())
	{
		IDirectDrawSurface *pSurface=*(IDirectDrawSurface **)0x478604;
		DDSURFACEDESC SurfaceDesc;
		SurfaceDesc.dwSize=sizeof(SurfaceDesc);

		pSurface->GetSurfaceDesc(&SurfaceDesc);
		int pitch=SurfaceDesc.lPitch;

		char tmp[640*400];
		char *dst2=dst;
		dst = tmp;
		for(int i=0;i<200;i++)
		{
			char *src0=src-320;
			if (i == 0)
				src0 = src;
			char *src1=src;
			char *src2=src+320;
			if (i == 199)
				src2 = src;
			char *dst0=dst;
			char *dst1=dst+640;

			scale2x_8_def(dst0, dst1, src0, src1, src2, 320);
			
			dst+=640;
			dst+=640;
			src+=320;
		}

		dst = dst2;
		src = tmp;
		for(int i=0;i<400;i++)
		{
			for(int j=0;j<640;j++)
			{
				*(dst+2*j) = *src;
				*(dst+2*j+1) = *src;
				*(dst+pitch+2*j) = *src;
				*(dst+pitch+2*j+1) = *src;
				src++;
			}
			
			dst+=pitch;
			dst+=pitch;
		}

		DD_SurfaceUnlock();
		DD_SurfaceFlip();
	}
}
